[USACO09FEB]Revamping Trails G「分层图」

[USACO09FEB]Revamping Trails G「分层图」

题目描述

Farmer John dutifully checks on the cows every day. He traverses some of the M (1 <= M <= 50,000) trails conveniently numbered 1..M from pasture 1 all the way out to pasture N (a journey which is always possible for trail maps given in the test data). The N (1 <= N <= 10,000) pastures conveniently numbered 1..N on Farmer John's farm are currently connected by bidirectional dirt trails. Each trail i connects pastures P1_i and P2_i (1 <= P1_i <= N; 1 <= P2_i <= N) and requires T_i (1 <= T_i <= 1,000,000) units of time to traverse.

He wants to revamp some of the trails on his farm to save time on his long journey. Specifically, he will choose K (1 <= K <= 20) trails to turn into highways, which will effectively reduce the trail's traversal time to 0. Help FJ decide which trails to revamp to minimize the resulting time of getting from pasture 1 to N.

TIME LIMIT: 2 seconds

输入格式

  • Line 1: Three space-separated integers: N, M, and K

  • Lines 2..M+1: Line i+1 describes trail i with three space-separated integers: P1_i, P2_i, and T_i

输出格式

  • Line 1: The length of the shortest path after revamping no more than K edges

题意翻译

约翰一共有 (N) 个牧场.由 (M) 条布满尘埃的小径连接。小径可以双向通行。每天早上约翰从牧场 (1) 出发到牧场 (N) 去给奶牛检查身体。

通过每条小径都需要消耗一定的时间。约翰打算升级其中 (K) 条小径,使之成为高速公路。在高速公路上的通行几乎是瞬间完成的,所以高速公路的通行时间为 (0)

请帮助约翰决定对哪些小径进行升级,使他每天从 (1) 号牧场到第 (N) 号牧场所花的时间最短。

输入输出样例

输入 #1

4 4 1 
1 2 10 
2 4 10 
1 3 1 
3 4 100 

输出 #1

1 

说明/提示

K is 1; revamp trail 3->4 to take time 0 instead of 100. The new shortest path is 1->3->4, total traversal time now 1.

思路分析

  • 从题表里的单调队列优化 (DP) 里找到了这道题,我一看,这不分层图板子吗???好像我上次讲分层图就是拿这个做的例子???还真有这道题???
  • 然后加边跑了一遍 (spfa) 发现被卡了(恶毒),改成了 (Dijkstra) 就没事了

上板子

Code

#include<bits/stdc++.h>
#include<queue>
const int maxn=1000000; //开大点,因为你新建了好多层图,不然会RE一大半,紫气东来~(bushi)
const int maxm=10000000;
using namespace std;
int head[maxn],vis[maxn],dis[maxn];

struct Edge{
	int to,next,val;
}edge[maxm];

int tot = 0;
void Addedge(int x,int y,int z){
	edge[++tot].to = y;
	edge[tot].val = z;
	edge[tot].next = head[x];
	head[x] = tot;
}
struct node{  //堆优化
	int num,dis;
	node(){}
	node(int x,int y){num=x;dis=y;}
	bool operator < (const node &a)const{
		return dis>a.dis;
	}
};
void Dij(int x){ //还是板子
	priority_queue<node>q;
	memset(dis,0x3f,sizeof(dis));
	dis[x] = 0;
	q.push(node(x,0));
	while(!q.empty()){
		node t = q.top();q.pop();
		int u = t.num;
		if(vis[u])continue;
		vis[u] = 1;
		for(int i = head[u];~i;i = edge[i].next){
			int v = edge[i].to;
			if(dis[v]>dis[u]+edge[i].val){
				dis[v] = dis[u]+edge[i].val;
				q.push(node(v,dis[v]));
			}
		}
	}
}
int main(){
	int n,m,k;scanf("%d%d%d",&n,&m,&k);
	memset(head,-1,sizeof(head));
	int End = (k+1)*n + 1; //算上原来的一共k+1层
	int a,b,c;
	for(int i = 1;i <= m;i++){
		scanf("%d%d%d",&a,&b,&c);
		for(int j = 0;j <= k;j++){
			Addedge(a+j*n,b+j*n,c); //同一层图,正常的边连接
			Addedge(b+j*n,a+j*n,c);
		}
		for(int j = 1;j <= k;j++){
			Addedge(a+(j-1)*n,b+j*n,0); //相邻两层图,用修改的边相连
			Addedge(b+(j-1)*n,a+j*n,0);
		}
	}
	for(int i = 0;i <= k;i++)Addedge(n*(1+i),End,0); //终点直通车
	Dij(1);	
	printf("%d",dis[End]);
	return 0;
}
原文地址:https://www.cnblogs.com/hhhhalo/p/13418820.html